#!/bin/sh

#
# Install this in libexec/ChomboVis, so there's no doubt as to where the
# *_unittest binaries are -- they're in the same directory.
#
# Run it from the directory it's in.

canonicals_dir=../../share/ChomboVis/test/canonicals
data_dir=../../share/ChomboVis/data

retval=0

# Need this for efence not to complain about how we clean up SaveToHDF5()
# file descriptors and other stuff:
export EF_ALLOW_MALLOC_0=1

#
# Iterate over the various tests.
#
for test_name in "ChomboHDF5_unittest" \
                 "ChomboHDF5_EBformattest" \
                 "VisDat_unittest"
do
  outfile=${test_name}.txt
  if   [ $test_name = "ChomboHDF5_unittest" ]; then
      infile=particles2D.hdf5
      executable=$test_name
  elif [ $test_name = "ChomboHDF5_EBformattest" ]; then
      infile=newebformat2d.hdf5
      executable="ChomboHDF5_unittest"
  elif [ $test_name = "VisDat_unittest" ]; then
      infile=particles3d.hdf5
      executable=$test_name
  fi

  export LD_PRELOAD=libefence.so.0
  ./$executable debug_level=4 infile=$data_dir/$infile > /tmp/$outfile 2>&1
  export LD_PRELOAD=
  cmp $canonicals_dir/$outfile /tmp/$outfile > /dev/null 2>&1
  retval=$?
  if [ $retval -ne 0 ]; then
      echo "***Failed " $test_name \
          ", diff $canonicals_dir/$outfile /tmp/$outfile="
      diff $canonicals_dir/$outfile /tmp/$outfile
  else
      echo "***Passed $test_name."
  fi
done 