//
// Takes ppid from command line.
//

#include <fcntl.h>
#include <iostream>
#include <cstdlib>
#include <string.h>
#include <signal.h>
#include <termios.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>

struct termios g_term;
int g_stdin_fd;

void save_termios()
{
    if( 0 != tcgetattr( g_stdin_fd, &g_term ) )
    {
        perror( "tcgetattr()" );
        exit(1);
    }
}

void restore_termios()
{
    if( 0 != tcsetattr( STDOUT_FILENO, TCSAFLUSH, &g_term ) )
    {
        perror( "tcsetattr()" );
        exit(2);
    }
    std::cerr << " " << std::endl;  // Seems to help prevent terminal seizure.
//  cerr << "Normal exit." << endl;
    exit(0);
}

void sighandler( int sig )
{
    restore_termios();
}

int
main( int argc, char * argv[] )
{
    if( argc != 3 )
    {
        std::cerr << "Usage: save_term <shell-pid> <shell-script pid>" << std::endl;
        exit(1);
    }

    int shell_pid = atoi( argv[1] );
    int script_pid = atoi( argv[2] );

    if( 0 != setpgid(0, shell_pid) )
    {
        perror( "setpgid():" );
        exit(3);
    }

    if( 0 >= (g_stdin_fd = open( ttyname( STDOUT_FILENO ), O_RDWR )))
    {
        perror( "open()" );
        exit(4);
    }
    
    save_termios();

    signal( SIGUSR1, sighandler );

    while( 1 )
    {    
        sleep(2);

        // Exit if the script from which we launched this program is dead.
        if( getpgid( script_pid ) < 0 )
        {
            std::cerr << "Killing save_term..." << std::endl;
            exit(5);
        }
    }

    return 0;
}
